//******************************************************************		
//*** 															 ***
//*** Author :  Alex Brussee									 ***
//*** 			xxlex@hotmail.com					9/07/2003 	 ***
//*** 															 ***
//******************************************************************		
//*** 															 ***
//*** "Muscle.java" provides muscles, which are in a certain     ***
//*** state of contraction										 ***
//*** 															 ***
//******************************************************************	

import java.awt.*;
import java.applet.Applet;

public class Muscle // must actually only be accessible to Limb !!!!!
{
	public boolean 
				active; // gives away if the muscle is active.
						// probleem : hoelang is een spier actief als er 90% oppervlak onder zit, bepaald tikker
	
	private double 	Xk,
					Yk,
					Alfa,
					Beta;
				
	private int ticker; // keeps record of time steps elapsed
									
	public Muscle(int RC1, int RC2) // constructor of muscle, activated by its timeconstants
	{
		Alfa = (double)(RC1)/1000; // initialisation of timeconstants (few hundredths)
		Beta = (double)(RC2)/1000;
		active = false;
		Xk = 0;
		Yk = 0;
	}
	
	public void Pulse(double Pulse) // sends activating pulse to muscle
	{
		Xk = 100 * Pulse * Alfa;
		Yk = Xk * Beta;
		ticker = 1;
		active = true;
	}
	
	public double Step(double Influence, int Weight) // one discrete timestep is performed
	{
		if(active) // the muscle is active so the next step can be made
		{
			Xk = (1 - Alfa) * Xk;
			Yk = Xk * Beta + (1 - Beta) * Yk;
			ticker++;
			Yk = Yk + Yk * (((double)Weight / 500) * (Influence / 1000)); // steer compensation for int number
			if(Yk < 1 && ticker > 200)
			{
				 active = false;
				 ticker = 0;
			}						
		}
		
		return(Yk);
	}
}