//******************************************************************		
//*** 									7						 ***
//*** Author :  Alex Brussee									 ***
//*** 			xxlex@hotmail.com					9/07/2003 	 ***
//*** 															 ***
//******************************************************************	
//*** 															 ***
//*** Java applet "Neural.java", shows how a model of a muscle 	 ***
//*** can be used to simulate movement. Differential motor		 ***
//*** control for a robot is the intented use					 ***
//*** 															 ***
//******************************************************************		

import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import javax.swing.*; 
import java.util.*;
   

public class Neural extends Applet implements ActionListener, AdjustmentListener, ItemListener, Runnable
{
//******************************************************************		
//*** Here some needed public values are initialised		     ***
//******************************************************************	

//	private Timer timer; // timer for real time simulation of pulse response

	private Thread animate;

	private int Amp_Max = 200,
				RC_Max = 256,
				Sample_Max = 1200; 
				
	public String Formula_str = "RcRcfilter";
	
	public int 	Init_RC1 	= 20, // initialisation values of Scrollbars, also usable for reset button.
				Init_RC2 	= 80,
				Init_Amp1 	= 80, 
				Init_Amp2 	= 40, 
				Init_Trans  = 0,
				Init_Time 	= 0,
				Ticker = 0; // time ticker for when first impulse is given. Delimited by Sample_Max
				
				
	public int 	RC1 = Init_RC1, // first Timeconstant of muscle model
				RC2 = Init_RC2, // second " " 
				Amp1 = Init_Amp1, // Amplification of first agonist
				Amp2 = Init_Amp2, // " second " 
				Trans  = Init_Trans,
				DTime= Init_Time; // delay times of first agonist, antagonist, second "" ""
			
	TextField	RC1_TF,
				RC2_TF,
				Amp1_TF,
				Amp2_TF,
				Trans_TF,
				Time_TF;

	Button 		Reset_B, // buttons to go back to original manual/train settings
				Go_B, // button to make robot drive in manual setting
				Train_B, // button to train robot in train mode
				Demo_B; // see what the robot can do with training sofar
				
	Scrollbar 	RC1_SB, // scrollbars to manually select RC values for generalised muscle
				RC2_SB,
				Amp1_SB,
				Amp2_SB,
				Trans_SB,
				Time_SB; // delay times for formulas
		
	Choice 		Formula;
					
	SpeedCanvas Speed_C;	
	SteerCanvas	Steer_C;	
	PathCanvas	Path_C;
	
	Formulas Calc;
	
	Muscle R_Speed;
	Muscle L_Speed;
	Muscle Steer_Muscle;

//******************************************************************		
//*** Here are calculation functions to various ends             ***
//******************************************************************	


									
//******************************************************************		
//*** Here the java applet is initialised						 ***	
//******************************************************************	
	public void init()
	{
		
		Reset_B = new Button("RESET"); 
		Go_B	= new Button("GO !"); // "MUSCLE" behind it if possible
		Train_B	= new Button("TRAIN");
		Demo_B	= new Button("DEMO");
		
		// Scrollbar : orietation, initial value, visible amount, min, max
		RC1_SB 	= new Scrollbar(Scrollbar.HORIZONTAL	, Init_RC1 , 1, 0, RC_Max);
		RC2_SB 	= new Scrollbar(Scrollbar.HORIZONTAL	, Init_RC2 , 1, 0, RC_Max);
		Amp1_SB = new Scrollbar(Scrollbar.VERTICAL		, Init_Amp1, 1, 0, Amp_Max);
		Amp2_SB = new Scrollbar(Scrollbar.VERTICAL		, Init_Amp2, 1, 0, Amp_Max);
		Trans_SB = new Scrollbar(Scrollbar.HORIZONTAL	, Init_Trans, 1, - Amp_Max, Amp_Max);

		RC1_TF 		= new TextField(String.valueOf(RC1  ), 3);
		RC2_TF 		= new TextField(String.valueOf(RC2  ), 3);
		Amp1_TF 	= new TextField(String.valueOf(Amp1 ), 3);
		Amp2_TF 	= new TextField(String.valueOf(Amp2 ), 3);
		Trans_TF 	= new TextField(String.valueOf(Trans), 3);
		Time_TF 	= new TextField(String.valueOf(DTime), 3);
		
		// choice must be added with right listener thingy		
				
		Time_SB	= new Scrollbar(Scrollbar.HORIZONTAL	, Init_Time, 1, 0, 2000);
					
		Formula = new Choice();
		
		Formula.add("RcRcfilter");
		Formula.add("Sinoid");
		Formula.add("Gauss");
	
		// add actionlisteners for buttons		
 		Reset_B.addActionListener(this); 
		Go_B.addActionListener(this);
		Train_B.addActionListener(this);
		Demo_B.addActionListener(this);

		// actionlisteners for the checkboxes and the choicebox
		Formula.addItemListener(this);		
		
		// choice must be added with right listener thingy		
		RC1_SB.addAdjustmentListener(this);
		RC2_SB.addAdjustmentListener(this);
		Amp1_SB.addAdjustmentListener(this);
		Amp2_SB.addAdjustmentListener(this);
		Trans_SB.addAdjustmentListener(this);
		Time_SB.addAdjustmentListener(this);

		Speed_C	= new SpeedCanvas(Sample_Max); // Three plotareas needed to plot graphics
		Steer_C	= new SteerCanvas(Sample_Max);
		Path_C	= new PathCanvas();
		
		Calc = new Formulas();

		setBackground(Color.black);
		setLayout(new GridLayout(1, 2)); // toplayergrid (y, x) : Muscles next to path 
			Panel PathPlot = new Panel();
			PathPlot.setLayout(new BorderLayout());
				Panel Path_UI = new Panel();
				Path_UI.setLayout(new GridLayout(1, 4));
					Path_UI.add(Formula);
					Path_UI.add(Go_B);
					Path_UI.add(Train_B);
					Path_UI.add(Demo_B);
					Path_UI.add(Reset_B);
				PathPlot.add("South", Path_UI);
				PathPlot.add("Center", Path_C);
		add(PathPlot);		
			Panel MusclePlot = new Panel();
			MusclePlot.setLayout(new BorderLayout());
				Panel Muscles = new Panel();
				Muscles.setLayout(new GridLayout(2, 1));
					Panel RMuscle = new Panel();
					RMuscle.setLayout(new BorderLayout());
						RMuscle.add("West",Amp1_SB);
						Panel RM_TF = new Panel();
							RM_TF.setLayout(new BorderLayout());
							RM_TF.add("West",Amp1_TF);
							RM_TF.add("Center",Time_SB);
							RM_TF.add("East",Time_TF);
						RMuscle.add("South",RM_TF);
						RMuscle.add("Center",Speed_C);
					Muscles.add(RMuscle);
					Panel LMuscle = new Panel();
					LMuscle.setLayout(new BorderLayout());
						LMuscle.add("West",Amp2_SB);
						LMuscle.add("Center",Steer_C);
						Panel LM_TF = new Panel();
							LM_TF.setLayout(new BorderLayout());
							LM_TF.add("West",Amp2_TF);
							LM_TF.add("Center",Trans_SB);
							LM_TF.add("East",Trans_TF);
						LMuscle.add("North",LM_TF);
					Muscles.add(LMuscle);
				MusclePlot.add("Center", Muscles);	
				Panel Muscles_UI2 = new Panel();
				Muscles_UI2.setLayout(new BorderLayout());
					Panel UI2_TF = new Panel();
						UI2_TF.setLayout(new GridLayout(1, 2));
						UI2_TF.add(RC1_SB);
						UI2_TF.add(RC2_SB);
					Muscles_UI2.add("West", RC1_TF);
					Muscles_UI2.add("Center", UI2_TF);
					Muscles_UI2.add("East", RC2_TF);					
				MusclePlot.add("South", Muscles_UI2);
		add(MusclePlot);	
			
		R_Speed = new Muscle(RC1, RC2);	
		L_Speed = new Muscle(RC1, RC2);	
		Steer_Muscle = new Muscle(RC1, RC2);
		
		UpdateCanvas();
	}
	
	
	public void FillCanvas() // fills the drawing areas when no muscle is active
	{
		double	Alfa = (double)(RC1)/1000, 
				Beta = (double)(RC2)/1000,
				Sp_R_Xk = 100 * Amp1 * Alfa, 
				Sp_R_Yk = Sp_R_Xk * Beta, 
				Sp_L_Xk = 100 * Amp1 * Alfa, 
				Sp_L_Yk = Sp_L_Xk * Beta, 
				St_Xk = 100 * Amp2 * Alfa, 
				St_Yk = St_Xk * Beta;
		
		for(int t = 1; t < Sample_Max; t++)
		{
			if(t > DTime)
			{
				St_Xk = (1 - Alfa) * St_Xk;
				St_Yk = St_Xk * Beta + (1 - Beta) * St_Yk;			
				Speed_C.S_Buffer[t] = St_Yk;
			} else Speed_C.S_Buffer[t] = 0;
			
			Sp_R_Xk = (1 - Alfa) * Sp_R_Xk;
			Sp_R_Yk = Sp_R_Xk * Beta + (1 - Beta) * Sp_R_Yk;
			Sp_R_Yk = Sp_R_Yk + Sp_R_Yk * (((double)Trans / 500) * (Speed_C.S_Buffer[t] / 1000));			
			Speed_C.R_Buffer[t] = Sp_R_Yk;

			Sp_L_Xk = (1 - Alfa) * Sp_L_Xk;
			Sp_L_Yk = Sp_L_Xk * Beta + (1 - Beta) * Sp_L_Yk;
			Sp_L_Yk = Sp_L_Yk - Sp_L_Yk * (((double)Trans / 500) * (Speed_C.S_Buffer[t] / 1000));			
			Speed_C.L_Buffer[t] = Sp_L_Yk;

						
		}
		
	}

//******************************************************************		
//*** here the thread started by pressing GO! button is handled  ***
//******************************************************************	
		
	public void run() // procedure for thread to keep accurate timing
	{
		int speed = 6;
		
    	while (Ticker < 300) 
    	{  // loop while canvas is not full
      		long t1 = (new Date()).getTime(); // first timer is set for accurate measure of processes

      		// in between timers processes can take place	

			Ticker+=1;
			
			if((Ticker > DTime) && (!Steer_Muscle.active) && (R_Speed.active))
			{
				Steer_Muscle.Pulse(Amp2); 
			}
			
			double Steer_Step = 0;
			
			if(Steer_Muscle.active)
			{
				Speed_C.T = (Ticker); // set discrete timer in canvas class to global timer
				Steer_Step = Steer_Muscle.Step(0, 0); // sets new value for next line segment
				Speed_C.S_Yt = Steer_Step; // sets new value for next line segment
				Speed_C.repaint(); // draws result to speed canvas				
			}
						
			Speed_C.T = Ticker; // set discrete timer in canvas class to global timer
			
			if(Steer_Muscle.active)
			{ 
				Speed_C.R_Yt = R_Speed.Step(Steer_Step, Trans);
				Speed_C.L_Yt = L_Speed.Step(-Steer_Step, Trans);
			} else 
			{
				Speed_C.R_Yt = R_Speed.Step(0, 0);
				Speed_C.L_Yt = L_Speed.Step(0, 0);
			}

			Speed_C.repaint(); // draws result to speed canvas
			      		
      		long t2 = (new Date()).getTime(); // second timer to calculate processing time
      		long sleepTime = speed - (t2 - t1);
      		if (sleepTime > 0) 
      		{
  	      		try {
    	      			Thread.sleep(sleepTime);
	        		}
    	    	catch (InterruptedException ie) {}    
	    	}
      	} 
      	
      	stop(); // stops the thread for reuse
      
    }
	
    public void stop() // stopping the thread
    {
    	// Stops and resets stuff after complete run ... important part of code
 
      	Ticker = 0; // reset Ticker
    	R_Speed = new Muscle(RC1, RC2);
    	L_Speed = new Muscle(RC1, RC2);
    	Steer_Muscle = new Muscle(RC1, RC2);
    	
        if (animate.isAlive()) 
        {
            animate = null;
        }
    }
	
//******************************************************************		
//*** from here on all action events like timers etc are handled ***	
//******************************************************************	

	public void itemStateChanged(ItemEvent evt) 
	{
		if(evt.getItemSelectable()  == Formula)
		{
			if(evt.getItem().equals("RcRcfilter")) {Formula_str = "RcRcfilter";}
			else if(evt.getItem().equals("Sinoid")) {Formula_str = "Sinoid";}
			else if(evt.getItem().equals("Gauss")) {Formula_str = "Gauss";}
				
		} 
  	}

  	public void UpdateCanvas()
  	{
		FillCanvas();
		Speed_C.repaint();
		Steer_C.repaint();
		Path_C.repaint();	
  	}

    public void adjustmentValueChanged(AdjustmentEvent evt) 
    { 	
		if (evt.getSource() == RC1_SB) 
		{
			RC1 = RC1_SB.getValue();
			RC1_TF.setText(String.valueOf(RC1));
			if((!R_Speed.active) && (!Steer_Muscle.active)) UpdateCanvas();
		} 
		else if (evt.getSource() == RC2_SB) 
		{
			RC2 = RC2_SB.getValue();
			RC2_TF.setText(String.valueOf(RC2));
			if((!R_Speed.active) && (!Steer_Muscle.active)) UpdateCanvas();
		}	    
		else if (evt.getSource() == Amp1_SB) 
		{
			Amp1 = (Amp_Max - Amp1_SB.getValue());
			Amp1_TF.setText(String.valueOf(Amp1));
			if((!R_Speed.active) && (!Steer_Muscle.active)) UpdateCanvas();
		}	    
		else if (evt.getSource() == Amp2_SB) 
		{
			Amp2 = Amp2_SB.getValue();
			Amp2_TF.setText(String.valueOf(Amp2));
			if((!R_Speed.active) && (!Steer_Muscle.active)) UpdateCanvas();
		}	    
		else if (evt.getSource() == Time_SB) 
		{
			DTime = Time_SB.getValue();
			Time_TF.setText(String.valueOf(DTime));
			if((!R_Speed.active) && (!Steer_Muscle.active)) UpdateCanvas();
		}	    
		else if (evt.getSource() == Trans_SB)
		{
			Trans = Trans_SB.getValue();
			Trans_TF.setText(String.valueOf(Trans));
			if((!R_Speed.active) && (!Steer_Muscle.active)) UpdateCanvas();
		}
	}
	
    public void actionPerformed(ActionEvent evt)  
    {
	    Object source = evt.getSource();
	    
		if (source == Reset_B) // reset is pushed so reset to initvaribles
		{
			RC1 = Init_RC1;
			RC2 = Init_RC2;
			Amp1 = Init_Amp1;
			Amp2 = Init_Amp2;
			DTime = Init_Time;
			Trans = Init_Trans;
						
			RC1_SB.setValue(RC1);
			RC2_SB.setValue(RC2);
			Amp1_SB.setValue(Amp1);
			Amp2_SB.setValue(Amp2);
			Time_SB.setValue(DTime);
			Trans_SB.setValue(Trans);

			UpdateCanvas();														
		}
		  
		if ((source == Go_B) && (Ticker == 0)) 
		{
			R_Speed = new Muscle(RC1, RC2);	
			L_Speed = new Muscle(RC1, RC2);	
			Steer_Muscle = new Muscle(RC1, RC2);
        	animate = new Thread(this);
			R_Speed.Pulse(Amp1); 
			L_Speed.Pulse(Amp1); 
			animate.start();
		}
	}    				 
}
